/* porkbind by Derek Callaway <super@udel.edu> -- S@IRC */

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<netinet/in.h>
#include<arpa/nameser.h>
#include<resolv.h>
#include<errno.h>
#include<netdb.h>
#include<unistd.h>
#include"dnsqry.h"

int main(int argc,char **argv){
	struct funcargs da;
	struct servers *start,*llp=0;
	struct hostent *host;
	/* Using char as variable type to perform bitwise operations upon
	 * because sizeof(char)==1 always according to standard. */
	char *server=NULL,*config=NULL,*domain;
	int c,count;
	union {
		HEADER hdr;
		char buf[PACKETSZ];
	} response;
	char buf[8096];
	setvbuf(stdout,buf,_IOFBF,(size_t)8096);
	spin();
	while((c=getopt(argc,argv,"s:c:b"))!=EOF){
		switch(c){
			case 0: puts(optarg);
				break;
			case '?':
				usage(argv);
			case 's': server=optarg;
				  break;
			case 'c': config=optarg;
				  break;
		}
	}
	res_init();
	_res.options&=~(RES_DNSRCH|RES_DEFNAMES);
	_res.options|=RES_RECURSE;
	_res.retry=2;
	if(server){
		spin();
		if(!(host=gethostbyname(server))){
			printf("Unable to resolve: %s\n",server);
			exit(EXIT_FAILURE);
		}
		spin();
		_res.nscount=1;
		memcpy((void*)&_res.nsaddr_list[0].sin_addr,(void*)host->h_addr_list[0],(size_t)host->h_length);
	}
	if(argv[optind]) domain=argv[optind];
	else {
		if(!(domain=(char*)malloc(MAXDNAME+1))) vexit("malloc");
		if(getdomainname(domain,MAXDNAME)<0) vexit("getdomainname");
		if(!strlen(domain)) usage(argv);
	}
	spin();
	if((c=res_query(domain,C_IN,T_NS,(unsigned char*)&response,sizeof(response)))<0){
		printf("Unable to retrieve nameserver records for: %s\n",domain);
		exit(EXIT_FAILURE);
	}
	spin();
        da.eom=response.buf+c;
        da.cp=response.buf+sizeof(HEADER);
        da.cp+=skipname(response.buf,da.cp,da.eom)+QFIXEDSZ;
	count=ntohs(response.hdr.ancount)+ntohs(response.hdr.nscount);
	if(!(start=llp=(struct servers*)malloc(sizeof(struct servers)))) vexit("malloc");
	llp->next=NULL,llp->ns=llp->ver=NULL;
	while((--count>=0)){
        	if(da.cp<da.eom){
			da.bufp=response.buf;
			da.cp+=skiptodata(&da);
			if(da.type==T_NS){
				if(!(llp->ns=(char*)malloc(MAXDNAME))) vexit("malloc");
				if((count=dn_expand(response.buf,da.eom,da.cp,llp->ns,MAXDNAME))<0) continue;
			}
			da.cp+=da.dlen;
		}
		if(!(llp->next=(struct servers*)malloc(sizeof(struct servers)))) vexit("malloc");
		llp=llp->next,llp->next=NULL,llp->ns=llp->ver=NULL;
	}
	for(llp=start;llp->ns;llp=llp->next){
		da.reserved=(void*)llp;
	       	vcheck(&da);
	}
	for(llp=start;llp->ns;llp=llp->next) report(llp,config);
	exit(EXIT_SUCCESS);
}
