#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<ctype.h>
#include<sys/types.h>
#include<unistd.h>
#include"dnsqry.h"

#define BUFSIZE 1024

struct config_entry {
	char *cond;
	char *vuln;
	char *advi;
	struct config_entry *next;
};

inline static void synerr(void);

int report(struct servers *llp,const char *config){
	FILE *cf;
	char buf[BUFSIZE],*op;
	register char *p;
	struct config_entry *confent,*start;
	size_t len;
	if(!(confent=(struct config_entry*)malloc(sizeof(struct config_entry)))) vexit("malloc");
	confent->next=NULL;
	if(config&&!(cf=fopen(config,"r"))) vexit("fopen");
	else if(!(cf=fopen("porkbind.conf","r"))) vexit("fopen");
	if(!(llp->ver)){
		printf("%s *Unable to determine version information for this server*\n",llp->ns);
		return(0);
	}
	/* Read configuration file entries into memory and organize them into
	 * a data structure.
	 */
	start=confent,confent->next=NULL;
	while(fgets(buf,BUFSIZE,cf)){
		op=buf,p=op;
		/* Comment -- ignore. */
		while(isspace(*p)) p++;
		if(*p=='#') continue;
		while(!isspace(*p)&&*p) p++;
		if(!*p) synerr();
		*p=0;
		len=p-op;
		if(!(confent->cond=(char*)malloc(len+1))) vexit("malloc");
		/* Paranoid strncpy()'s follow. */
		strncpy(confent->cond,op,len);
		*(confent->cond+len)=0;
		p++;
		while(*p!='"'&&isspace(*p)) p++;
		op=++p;
		while(*p&&*p!='"') p++;
		if(!*p) synerr();
		*p=0;
		len=p-op;
		if(!(confent->vuln=(char*)malloc(len+1))) vexit("malloc");
		strncpy(confent->vuln,op,len);
		*(confent->vuln+len)=0;
		p++;
		while(isspace(*p)) p++;
		op=p;
		while(!isspace(*p)&&*p) p++;
		if(!*p) synerr();
		*p=0;
		len=p-op;
		while(!(confent->advi=(char*)malloc(len+1))) vexit("malloc");
		strncpy(confent->advi,op,len);
		*(confent->advi+len)=0;
		if(!(confent->next=(struct config_entry*)malloc(sizeof(struct config_entry)))) vexit("malloc");
		confent=confent->next;
		confent->next=NULL;
	}
	if(confent->next){
	       	free(confent->next);
		confent->next=NULL;
	}
	for(confent=start;confent->next;confent=confent->next){
		int ret;
		if((ret=chkver(llp->ver,confent->cond))){
			printf("%s may be vulnerable to %s as described in %s\n",llp->ns,confent->vuln,confent->advi);
		}
	}
	return(0);
}
		
static void synerr(void){
	puts("Syntax error in porkbind.conf");
	exit(EXIT_FAILURE);
}
